<?
require("header.inc");

$result = pg_exec($link, "select * from $table");
$num_of_fields = pg_numfields($result);
if (!$result)
   {
   pg_die();
   }
else
   {
   ?>
   <table border=1>
   <tr>
   <th>Field</th>
   <th>Type</th>
<!--   
   <th>Null</th>
   <th>Default</th>
-->

   <th>Extra</th>

   </tr>

   <?
   $i = 0;
   while ($i < $num_of_fields)
         {
	 $query = "db=$db&table=$table";
	
	$extra = pg_exec($link, "SELECT ic.relname 
             FROM pg_class bc,             
                  pg_class ic,             
                  pg_index i,
                  pg_attribute a           
             WHERE 
	not bc.relname~'pg_.*'
	and i.indrelid = bc.oid
                and i.indexrelid = ic.oid
                and i.indkey[0] = a.attnum
                and a.attrelid = bc.oid
                and i.indproc = '0'::oid");
	 if (pg_numrows($extra) < 1) {
		$Extra ="";
	 } else {
		$extra = pg_fetch_row($extra, 0);
		$Extra = $extra[0];
	 }
	 $indexed = 0;
	 $field = pg_fieldname($result, $i);
         $type = pg_fieldtype($result, $i);
        if (substr($type, 0, 1) == "_") {
                $type = substr($type, 1, strlen($type)). "[]";
        } 
	 $i++;
	 ?>
         <tr>
         <td><? echo $field;?>&nbsp;</td>
         <td><? echo $type;?>&nbsp;</td>
        
	<!-- 
	<td><? if ($row[Null] == "") { echo "NO";} else {echo $row[Null];}?>&nbsp;</td>
         <td><? echo $row["Default"];?>&nbsp;</td>
	-->

         <td><? if ($Extra == $field) {
			echo "indexed";
			$indexed = 1;
		} ?>&nbsp;</td>

         <td><a href=tbl_alter.php3?<? echo $query;?>&field=<? echo $field;?>>Change</a></td>
         <td><a href=sql.php3?<? echo $query;?>&sql_query=<? echo urlencode("ALTER TABLE $table DROP $field");?>&zero_rows=<? echo urlencode("$field has been dropped.");?>>Drop</a></td>

	<!--
         <td><a href=sql.php3?<? echo $query;?>&sql_query=<? echo urlencode("ALTER TABLE $table ADD PRIMARY KEY($field)");?>&zero_rows=<? echo urlencode("A primary key has been added on $field.");?>>Primary</a></td>
	-->

         <td><?
		if ($indexed == 0) {
			print "<a href=sql.php3?$query&sql_query=".urlencode("CREATE INDEX $field on $table USING btree($field)")."&zero_rows=".urlencode("An index has been added on $field.").">";
		}
	     ?>Index</a></td>
         </tr>
         <?
         }
   ?>
   </table>
   <?
   }

?>
<table border=1>
<?
/*
$result = mysql_db_query($db, "SHOW KEYS FROM $table");
if (!$result)
   {
   pg_die();
   }
else
   {
   for ($i=0 ; $i<pg_numrows($result); $i++)
       {
       $row = mysql_fetch_array($result);
       echo "<tr>";
       if ($row[Key_name] == "PRIMARY")
          {
          $sql_query = urlencode("ALTER TABLE $table DROP PRIMARY KEY");
          $zero_rows = urlencode("Primary key has been dropped.");
          }
       else
          {
          $sql_query = urlencode("ALTER TABLE $table DROP INDEX $row[Key_name]");
          $zero_rows = urlencode("Index $row[Key_name] has been dropped.");
          }
       echo "<td>$row[Key_name]</td><td>$row[Column_name]</td><td><a href=sql.php3?$query&sql_query=$sql_query&zero_rows=$zero_rows>Drop</a></td>";
       echo "</tr>";
       }
   }
*/
?>

</table>
<div align="left">
<ul>
<li><a href=tbl_addfield.php3?<? echo $query;?>>Add new field</a>
<li><a href=tbl_dump.php3?<? echo $query;?>>View dump (schema) of table</a>
</ul>
</div>
<?
require ("footer.inc");
?>
