<?
require("config.inc");

if ($persistent_connections)
   {
   $link = pg_pconnect("user=$user dbname=$dbname port=$port");
   }
else
   {
   $link = pg_connect("user=$user dbname=$dbname port=$port");
   }

// -----------------------------------------------------------------

function pg_die()
 {
 echo "<b>Error</b><p>";
 echo "PostgreSQL said: ".pg_errormessage();
 require ("footer.inc");
 exit;
 }

function display_table ($dt_result)
 {
 global $bgcolor_one, $bgcolor_two, $max_rows, $pos, $db, $table, $sql_query;
 $primary = false;
 
 ?>
 <table border="1"> 
  <tr> 
  <? 
  
  $k = 0;
  while ($k < pg_numfields($dt_result)) { 
	$field = pg_fieldname($dt_result, $k);
	echo "<th>$field</th>\n"; 
        #$table = $field->table;
        $k++;
	} 
  echo "</tr>\n"; 
  
  $foo = 0;
  if (!isset($pos))
     {
     $pos = 0;
     }
  $pos_next = $pos + $max_rows;
  $pos_prev = $pos - $max_rows;  

  $j = 0;
  while ($j < pg_numrows($dt_result))
        {
        $row = pg_fetch_row($dt_result, $j);
	$j++;
	if ($foo < $pos_next && $foo >= $pos) 
           {
           $primary_key = "";
           $bgcolor = $bgcolor_one;
           $foo % 2  ? 0: $bgcolor = $bgcolor_two;
           echo "<tr bgcolor=$bgcolor>"; 
           for ($m=0; $m<pg_numfields($dt_result); $m++) 
               { 
               $row[$m] = StripSlashes($row[$m]);
	       echo "<td>&nbsp;$row[$m]&nbsp;</td>\n"; 
               $primary = pg_fetch_object($dt_result,$i);
               if ($primary->primary_key > 0)
                  {
                  $primary_key .= " $primary->name = '$row[$m]' AND";
                  }
               } 
           if ($primary_key)
              {
              $primary_key = urlencode(ereg_replace("AND$", "", $primary_key));
              $query = "&db=$db&table=$table";
              echo "<td><a href=tbl_change.php3?$query&primary_key=$primary_key>Edit</a></td>";
              echo "<td><a href=sql.php3?$query&sql_query=".urlencode("DELETE FROM $table WHERE $primary_key")."&zero_rows=".urlencode("The row has been deleted").">Delete</a></td>";
              }
           echo "</tr>\n"; 
           }
        $foo++;
        } 
 echo "</table>\n"; 
 if ($pos >= $max_rows)
    {
    echo "<a href=sql.php3?db=$db&table=$table&sql_query=".urlencode($sql_query)."&pos=$pos_prev>&lt; Previous </a>";
    }
 if ($pos_next < pg_numrows($dt_result))
    {
    echo "<a href=sql.php3?db=$db&table=$table&sql_query=".urlencode($sql_query)."&pos=$pos_next>Next &gt;</a>";

    }
 }

// -----------------------------------------------------------------

/*
$query_string = "\\l";
$dbs = pg_exec($link, $query_string);
$num_dbs = pg_numrows($dbs);
$i = 0;
*/

?>
<html>
<head>
<title>postgresAdmin</title>
<style type="text/css">
//<!--
body {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt}
.nav {  font-family: Verdana, Arial, Helvetica, sans-serif; color: #000000}
th   {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt; font-weight: bold}
td   {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt;}
form   {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt}
h1   {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 16pt; font-weight: bold}
A:link    {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt; text-decoration: none}
A:visited {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt; text-decoration: none}
A:hover   {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt; text-decoration: underline; color: red}
//-->
</style></head>

<body bgcolor="#FFFFFF" text="#000000">
<table border="0">
  <tr>
    <td valign="top">
    <img src="images/spacer.gif" width="75" height="1"><br>
    <a href="index.php3" class=nav>Home</a><br>
<?

#echo "<p class=nav>$num_dbs databases</p>\n";

#while ($i < $num_dbs)
#      {
#      $db_name = pg_dbname($link);
#	if ($dbname == $user) {
	echo "<a href=db_details.php3?db=$dbname class=nav>$dbname</a><br>\n";
#	}
#      $i++;
#      }

?>
    </td>
    <td align="center" valign="top"> 
<?
if (isset($db))
   {
   echo "<h1>Database $db";
   if (isset($table))
      {
      echo " - table $table";
      }
   echo "</h1>";
   }
?>
